// -*-C++-*- 

/*  src/iter/enumerations/ESequence.cpp  */


/*
 * Author: Philogelos A. <Philogelos@yahoo.com>
 * Maintainer: Philogelos A.
 * Keywords: C++, library, containers
 *
 * Copyright (C) 1998 Philogelos A.
 *
 * This file is part of Quercus Robusta.
 *
 * Quercus Robusta is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this software; see the file COPYING.LIB.  If not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */


/* $Id: ESequence.cpp,v 1.3 1999/03/03 19:09:44 philogelos Exp $ */
#if !defined(_INLINE)
static char cvsid[] = "@(#)$Id: ESequence.cpp,v 1.3 1999/03/03 19:09:44 philogelos Exp $";
static char debugFileId[] = __FILE__;
#endif


#include "iter/enumerations/ESequence.hpp"
#include "LinkManager.hpp"
#include "String.hpp"
#include "Debug.hpp"

Top *ESequence::getNextElement()
{
  return getNextEnumeration();
}

ESequence *ESequence::createFrom( TypedEnumeration< Enumeration > *anEnum )
{
  return new ESFromTyped( anEnum );
}

ESFromTyped::ESFromTyped( TypedEnumeration< Enumeration > *anEnum )
{
  FNNINIT( enumeration, anEnum );
}

ESFromTyped::~ESFromTyped()
{
  FDONE( enumeration );
}

Enumeration *ESFromTyped::getNextEnumeration()
{
  return( enumeration -> getNextTypedElement() );
}

boolean ESFromTyped::hasMoreElements()
{
  return( enumeration -> hasMoreElements() );
}

String  ESFromTyped::getClassName() const
{
  return "ESFromTyped";
}

Top    *ESFromTyped::clone() const
{
  return new ESFromTyped( enumeration );
}


#if defined(_INLINE)
#include "../src/Debug.ipp"
#endif

/* $Log: ESequence.cpp,v $
 * Revision 1.3  1999/03/03 19:09:44  philogelos
 * Put sources under GNU Library License
 *
 * Revision 1.2  1999/02/28 16:30:47  philogelos
 * Tuned for inlines.
 *
 * Revision 1.1.1.1  1998/11/25 20:11:03  philogelos
 * Quercus Robusta
 * */
